package manejoXML;

import global.GlobalData;

import java.io.*;
import java.util.StringTokenizer;
//DOM classes.
import org.w3c.dom.*;
//Para exportar Document a archivo xml
//import com.sun.org.apache.xml.internal.serialize.XMLSerializer;
//JAXP
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

//ContenidoFichero
import lectura_ficheros.ContenidoFichero;

public class ArchivoXML {

	Document ContenidoFichero2XML(ContenidoFichero cf){
		// Create XML DOM document (Memory consuming).
		Document xmldoc = null;
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = null;
		try {
			builder = factory.newDocumentBuilder();
		} catch (ParserConfigurationException e1) {
			e1.printStackTrace();
		}
		DOMImplementation impl = builder.getDOMImplementation();
		
		Element e = null;
		Node n = null;
		// Document.
		xmldoc = impl.createDocument(null, "ConjuntoDatos", null);
		// Root element.
		Element root = xmldoc.getDocumentElement();

		int[] numCampos = new int[1];
	
		int numTuplas = cf.countTuplas(); 
		
		for (int i=0;i<numTuplas;i++)
		{
			String [][] separados = estudiarCampoMultiple(cf, i, numCampos);
			
			// Child i.
			for (int k=0; k<numCampos[0]; k++){
				e = xmldoc.createElementNS(null, "Tupla");
				
				for (int j=0;j<GlobalData.Campo.length;j++){
					Element e2 = xmldoc.createElementNS(null, GlobalData.Campo[j]);
					//Si la primera linea de los datos es un total de los datos siguientes
					//lo almacenamos con un nivel de jerarquia superior
					if (cf.getPrimeraLineaTotal() && i == 0 && j == GlobalData.indexOfCampo("Nivel")){
						separados[k][j] = GlobalData.JerarquiaRegiones[GlobalData.indexOfJerarquiaRegiones(separados[k][j]) + 1];
						n = xmldoc.createTextNode(separados[k][j].trim());
					}else{
						n = xmldoc.createTextNode(separados[k][j].trim());
					}
					e2.appendChild(n);
					e.appendChild(e2);
				}
				root.appendChild(e);
			}	
		}
		
		return xmldoc;

	}
	
	/**
	 * 
	 * */
	public String[][] estudiarCampoMultiple(ContenidoFichero cf, int tupla, int[] numCampos){
		
		String[] metadatos = cf.getMetadatos();
		StringTokenizer st = new StringTokenizer (metadatos[GlobalData.indexOfMetadato("Variable")], ";");	//variable de estudio
		int nst = st.countTokens();
		StringTokenizer st2 = new StringTokenizer (metadatos[GlobalData.indexOfMetadato("Fecha")], ";");	//fecha
		int nst2 = st2.countTokens();
		
		String[][] datosSeparados = null;
		
		if (nst > nst2){
			datosSeparados = new String[nst][GlobalData.Campo.length];
			for (int i=0; i<nst; i++){
				datosSeparados[i][GlobalData.indexOfCampo("Variable")] = st.nextToken();	// Variable de estudio
				datosSeparados[i][GlobalData.indexOfCampo("AditividadTemporal")] = metadatos[GlobalData.indexOfMetadato("AditividadTemporal")];	//AditividadTemporal
				datosSeparados[i][GlobalData.indexOfCampo("AditividadEspacial")] = metadatos[GlobalData.indexOfMetadato("AditividadEspacial")];	//AditividadEspacial
				datosSeparados[i][GlobalData.indexOfCampo("Frecuencia")] = metadatos[GlobalData.indexOfMetadato("Frecuencia")];	//Frecuencia
				datosSeparados[i][GlobalData.indexOfCampo("Fecha")] = metadatos[GlobalData.indexOfMetadato("Fecha")];	//Fecha
				datosSeparados[i][GlobalData.indexOfCampo("Unidades")] = metadatos[GlobalData.indexOfMetadato("Unidades")];	//Unidades
				datosSeparados[i][GlobalData.indexOfCampo("Lugar")] = cf.getDataAt(tupla, 0);	//Lugar
				datosSeparados[i][GlobalData.indexOfCampo("Nivel")] = metadatos[GlobalData.indexOfMetadato("Nivel")];		//Nivel	
				datosSeparados[i][GlobalData.indexOfCampo("TipoDato")] = metadatos[GlobalData.indexOfMetadato("TipoDato")];	//TipoDato
				datosSeparados[i][GlobalData.indexOfCampo("NaturalezaDato")] = metadatos[GlobalData.indexOfMetadato("NaturalezaDato")];	//NaturalezaDato
				datosSeparados[i][GlobalData.indexOfCampo("Valor")] = cf.getDataAt(tupla, i+1);	//Valor -- i+1 para ignorar el lugar
				datosSeparados[i][GlobalData.indexOfCampo("OrigenDatos")] = metadatos[GlobalData.indexOfMetadato("OrigenDatos")];	//OrigenDatos
				//TODO aqui se aaden las demas asignaciones en caso de modificar el diseo
			}
			numCampos[0] = nst;
		}else{
			datosSeparados = new String[nst2][GlobalData.Campo.length];
			for (int i=0; i<nst2; i++){
				datosSeparados[i][GlobalData.indexOfCampo("Variable")] = metadatos[GlobalData.indexOfMetadato("Variable")];	// Variable de estudio
				datosSeparados[i][GlobalData.indexOfCampo("AditividadTemporal")] = metadatos[GlobalData.indexOfMetadato("AditividadTemporal")];	//AditividadTemporal
				datosSeparados[i][GlobalData.indexOfCampo("AditividadEspacial")] = metadatos[GlobalData.indexOfMetadato("AditividadEspacial")];	//AditividadEspacial
				datosSeparados[i][GlobalData.indexOfCampo("Frecuencia")] = metadatos[GlobalData.indexOfMetadato("Frecuencia")];	//Frecuencia
				datosSeparados[i][GlobalData.indexOfCampo("Fecha")] = st2.nextToken();	//Fecha
				datosSeparados[i][GlobalData.indexOfCampo("Unidades")] = metadatos[GlobalData.indexOfMetadato("Unidades")];	//Unidades
				datosSeparados[i][GlobalData.indexOfCampo("Lugar")] = cf.getDataAt(tupla, 0);	//Lugar
				datosSeparados[i][GlobalData.indexOfCampo("Nivel")] = metadatos[GlobalData.indexOfMetadato("Nivel")];		//Nivel	
				datosSeparados[i][GlobalData.indexOfCampo("TipoDato")] = metadatos[GlobalData.indexOfMetadato("TipoDato")];	//TipoDato
				datosSeparados[i][GlobalData.indexOfCampo("NaturalezaDato")] = metadatos[GlobalData.indexOfMetadato("NaturalezaDato")];	//NaturalezaDato
				datosSeparados[i][GlobalData.indexOfCampo("Valor")] = cf.getDataAt(tupla, i+1);	//Valor -- i+1 para ignorar el lugar
				datosSeparados[i][GlobalData.indexOfCampo("OrigenDatos")] = metadatos[GlobalData.indexOfMetadato("OrigenDatos")];	//OrigenDatos
				//TODO aqui se aaden las demas asignaciones en caso de modificar el diseo
			}
			numCampos[0] = nst2;
		}
		return datosSeparados;
	}
	
	public void guardarFicheroXMLdeContenidoFichero(File fichero, ContenidoFichero cf){
		//creamos el fichero xml
		File fich = new File("./datos_en_XML/" + fichero.getName() + ".xml");
		if (fich.exists()){
			fich.delete();
		}
		
		Document docxml = ContenidoFichero2XML(cf);
		
		RandomAccessFile fichero2 = null;
		try {
			
			fichero2 = new RandomAccessFile( fich, "rw");
		    //escribimos los datos en el archivo
		    fichero2.writeBytes(getStringFromDocument(docxml));
		    
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	//method to convert Document to String
	public String getStringFromDocument(Document doc)
	{
	    try
	    {
	       DOMSource domSource = new DOMSource(doc);
	       StringWriter writer = new StringWriter();
	       StreamResult result = new StreamResult(writer);
	       TransformerFactory tf = TransformerFactory.newInstance();
	       Transformer transformer = tf.newTransformer();
	       transformer.transform(domSource, result);
	       return writer.toString();
	    }
	    catch(TransformerException ex)
	    {
	       ex.printStackTrace();
	       return null;
	    }
	} 
}
